package com.example.zxweb.utils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.example.zxweb.common.constant.enums.IotApiEnum;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description ios 设备请求工具
 * @Author ZhouWenTao
 * @Date 2023/9/8 11:59
 */
@Component
public class IotUtils {
    //请求服务地址                              https://10.0.10.153:2443/api/iot/v1
    private static final String API_PREFIX = "https://10.0.10.153:2443/api/iot/v1";

    private static final JSONObject headers=JSONObject.parseObject("{\"x-consumer-username\":\"dwVendor\",\"appCode\":\"42142fd0jkbf4515853b7fcec64748f6\"}");

    public static List<JSONObject> devicesMethodsNews(JSONObject queryData){
        String serial = queryData.getString("serial");
        String[] serials = serial.split(",");
        List<JSONObject> list=new ArrayList<>();
        for (String s : serials) {
            String url = API_PREFIX + IotApiEnum.getPathByText("查询方法历史数据") + "?serial=" + s;
            if (!StringUtils.isEmpty(queryData.getString("methodName"))) {
                url+="&methodName="+queryData.getString("methodName");
            }
            JSONObject jsonObject = RestUtil.get(url, null, null, headers);
            Integer code = jsonObject.getInteger("code");
            if (code==0) {
                if (jsonObject.getJSONObject("data")==null) {
                    continue;
                }
                JSONArray jsonArray = jsonObject.getJSONObject("data").getJSONArray("methods");
                if (CollectionUtils.isEmpty(jsonArray)) {
                    continue;
                }
                list.add(jsonArray.getJSONObject(0));
            }
        }
        return list;
    }

    public static JSONObject getApi(String apiUrl,JSONObject queryData) {

        StringBuilder sb=new StringBuilder();
        int i=0;
        for (String field : queryData.keySet()) {
            String value = (String) queryData.get(field);
            if (StringUtils.isEmpty(value)) {
                continue;
            }
            sb.append(i==0?"?":"&");
            sb.append(field).append("=").append(value);
            i++;
        }
        return RestUtil.get(API_PREFIX+apiUrl+sb,null,null,headers);
    }

    public static JSONObject postApi(String apiUrl,JSONObject requestBody){
        return RestUtil.post(API_PREFIX+apiUrl,requestBody,headers);
    }
}
